﻿// lab1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <cmath>

using namespace std;



struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cout << "Enter number of bins";
    cin >> in.bin_count;
    return in;
}

void find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    for (auto i = 0; i < numbers.size(); i++) {
        if (numbers[i] < min) {
            min = numbers[i];
        }
    }

    max = numbers[0];
    for (auto i = 0; i < numbers.size(); i++) {
        if (numbers[i] > max) {
            max = numbers[i];
        }
    }

}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count) {

    vector<size_t> bins(bin_count);
    vector<size_t> binss(bin_count);

    double max, min;
    find_minmax(numbers, min, max);
    double bin_size = (max / min) / bin_count;

    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    int max_count = bins[0];
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }

    if (max_count > 76) {

        for (size_t i = 0; i < bin_count; i++) {
            int count = bins[i];
            size_t height = 76 * (static_cast<double>(count) / max_count);
            bins[i] = height;
        }
    }
    return bins;
}

void show_histogram_text(vector <size_t> bins, size_t bin_count) {

    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] < 100) {
            cout << " ";
        }
        if (bins[i] < 10) {
            cout << " ";
        }
        cout << bins[i] << "|";
        for (size_t j = 0; j < bins[i]; j++) {
            cout << "*";
        }
        cout << "\n";
    }
}



int main()
{
    Input in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);


}